#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BNO055.h>
#include <math.h>

#define motA 12
#define motB 13
#define pwmA 3
#define pwmB 11
#define potKp A3
#define potKd A2


float goal, curPos, pastPos, propE, dirivE, dirivEcur, dirivEpast, intE, error, power = 0;
unsigned long startT;
unsigned long delT = .1;
float Kp, Kd = 2;
float alpha = 0.2;

Adafruit_BNO055 bno = Adafruit_BNO055(55);
sensors_event_t angVelocityData;


void setup(void)
{
//  Serial.begin(9600);
  pinMode(pwmA, OUTPUT);
  pinMode(pwmB, OUTPUT);
  pinMode(motA, OUTPUT);
  pinMode(motB, OUTPUT);

  pinMode(potKp, INPUT);
  pinMode(potKd, INPUT);
  //Serial.println("Orientation Sensor Test"); Serial.println("");

  /* Initialise the sensor */
  if (!bno.begin())
  {
    /* There was a problem detecting the BNO055 ... check your connections */
    Serial.print("Ooops, no BNO055 detected ... Check your wiring or I2C ADDR!");
    while (1);
  }

  delay(1000);

  bno.setExtCrystalUse(true);

}

void loop(void)
{
  unsigned long init_time = millis();
  while (millis() - init_time < 300){
    digitalWrite(motA, LOW);
    digitalWrite(motB, LOW);
    analogWrite(pwmA, 255);
    analogWrite(pwmB, 255);
  }
  digitalWrite(motA, LOW);
  digitalWrite(motB, LOW);
  analogWrite(pwmA, 255);
  analogWrite(pwmB, 255);
}
//  sensors_event_t event;
//  bno.getEvent(&event);
//  bno.getEvent(&angVelocityData, Adafruit_BNO055::VECTOR_GYROSCOPE);
//    
//  //int KpPot = analogRead(potKp);
//  //int KdPot = analogRead(potKd);
//  
////  //Kp = map(analogRead(potKp), 0, 1023, 0, 30);
////  Kp = (6./1023)*analogRead(potKp) + 33;
//  //Kd = map(analogRead(potKd), 0, 1023, 0, 10);
////  Kd = (5./1023)*analogRead(potKd);
//
//  Kp = 58;  //35
//  Kd = 3;
//
//
////  Serial.print("Kp");
////  Serial.println(Kp);
////  Serial.print("Kd");
////  Serial.println(Kd);
////  
//  /* Get a new sensor event */
//  startT = millis();
//  curPos = event.orientation.z;
//  
//
//  propE = curPos - goal;
//  //dirivEcur = (curPos - pastPos)*1.0 / 1.0*delT;
//  dirivEcur = (-50 * (&angVelocityData)->gyro.z);
//  dirivE = alpha*dirivEcur*1.0 + (1-alpha)*dirivEpast*1.0;
////  Serial.print(dirivE);
////  Serial.print(",");
////  Serial.print(dirivEcur);
////  Serial.print(",");
////  Serial.println(-1 * (50 * (&angVelocityData)->gyro.z));
//
//  // intE = intE + (propE)*delT;
//
//  error = Kp * propE + Kd*dirivE;
//  //error = Kp * propE + Kd*dirivE;
////  Serial.print(propE);
////  Serial.print(",");
////  Serial.println(-50 * (&angVelocityData)->gyro.z);
//// Serial.print("error total ");
//// Serial.println(error);
//  //Serial.print("error prop ");
//  //Serial.println(propE*Kp,4);
//  //Serial.println(curPos, 4);
////  Serial.println("curPos");
////  Serial.println(curPos);
//  error = constrain(error, -400, 400);
////Serial.println(error);
////  if (abs(event.orientation.z)  < 2) {
////    error = 0;
////  }
//  if (error > 0) {
//    power = map(error, 0, 400, 0, 255);
//    digitalWrite(motA, HIGH);
//    digitalWrite(motB, HIGH);
//    analogWrite(pwmA, power);
//    analogWrite(pwmB, power);
//  }
//  else if (error < 0) {
//    power = map(error, 0, -400, 0, 255);
//    digitalWrite(motA, LOW);
//    digitalWrite(motB, LOW);
//    analogWrite(pwmA, power);
//    analogWrite(pwmB, power);
//  } else {
//    analogWrite(pwmA, 0);
//    analogWrite(pwmB, 0);
//  }
//  
//
//
//
//  /* Display the floating point data */
//  //  Serial.print("\troll: "); --> // the one we want to change
//  //  Serial.print(event.orientation.z, 4);
//
//  pastPos = curPos;
//  dirivEpast = dirivE;
//
//  delT = millis() - startT;
//
//
//
//
//
//
//}
//
//
////void printEvent(sensors_event_t* event) {
////  double x = -1000000, y = -1000000 , z = -1000000; //dumb values, easy to spot problem
////  if (event->type == SENSOR_TYPE_ACCELEROMETER) {
////    Serial.print("Accl:");
////    x = event->acceleration.x;
////    y = event->acceleration.y;
////    z = event->acceleration.z;
////  }
////  else if (event->type == SENSOR_TYPE_ORIENTATION) {
////    Serial.print("Orient:");
////    x = event->orientation.x;
////    y = event->orientation.y;
////    z = event->orientation.z;
////  }
////  else if (event->type == SENSOR_TYPE_MAGNETIC_FIELD) {
////    Serial.print("Mag:");
////    x = event->magnetic.x;
////    y = event->magnetic.y;
////    z = event->magnetic.z;
////  }
////  else if (event->type == SENSOR_TYPE_GYROSCOPE) {
////    Serial.print("Gyro:");
////    x = event->gyro.x;
////    y = event->gyro.y;
////    z = event->gyro.z;
////  }
////  else if (event->type == SENSOR_TYPE_ROTATION_VECTOR) {
////    Serial.print("Rot:");
////    x = event->gyro.x;
////    y = event->gyro.y;
////    z = event->gyro.z;
////  }
////  else if (event->type == SENSOR_TYPE_LINEAR_ACCELERATION) {
////    Serial.print("Linear:");
////    x = event->acceleration.x;
////    y = event->acceleration.y;
////    z = event->acceleration.z;
////  }
////  else if (event->type == SENSOR_TYPE_GRAVITY) {
////    Serial.print("Gravity:");
////    x = event->acceleration.x;
////    y = event->acceleration.y;
////    z = event->acceleration.z;
////  }
////  else {
////    Serial.print("Unk:");
////  }
////
////  Serial.print("\tx= ");
////  Serial.print(x);
////  Serial.print(" |\ty= ");
////  Serial.print(y);
////  Serial.print(" |\tz= ");
////  Serial.println(z);
//}
